// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from tuw_multi_robot_msgs:msg/RouterStatus.idl
// generated code does not contain a copyright notice
#include "tuw_multi_robot_msgs/msg/detail/router_status__rosidl_typesupport_fastrtps_cpp.hpp"
#include "tuw_multi_robot_msgs/msg/detail/router_status__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace tuw_multi_robot_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_tuw_multi_robot_msgs
cdr_serialize(
  const tuw_multi_robot_msgs::msg::RouterStatus & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: id
  cdr << ros_message.id;
  // Member: success
  cdr << (ros_message.success ? true : false);
  // Member: missing_robots
  {
    cdr << ros_message.missing_robots;
  }
  // Member: duration
  cdr << ros_message.duration;
  // Member: overall_path_length
  cdr << ros_message.overall_path_length;
  // Member: longest_path_length
  cdr << ros_message.longest_path_length;
  // Member: priority_scheduling_attemps
  cdr << ros_message.priority_scheduling_attemps;
  // Member: speed_scheduling_attemps
  cdr << ros_message.speed_scheduling_attemps;
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_tuw_multi_robot_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  tuw_multi_robot_msgs::msg::RouterStatus & ros_message)
{
  // Member: id
  cdr >> ros_message.id;

  // Member: success
  {
    uint8_t tmp;
    cdr >> tmp;
    ros_message.success = tmp ? true : false;
  }

  // Member: missing_robots
  {
    cdr >> ros_message.missing_robots;
  }

  // Member: duration
  cdr >> ros_message.duration;

  // Member: overall_path_length
  cdr >> ros_message.overall_path_length;

  // Member: longest_path_length
  cdr >> ros_message.longest_path_length;

  // Member: priority_scheduling_attemps
  cdr >> ros_message.priority_scheduling_attemps;

  // Member: speed_scheduling_attemps
  cdr >> ros_message.speed_scheduling_attemps;

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_tuw_multi_robot_msgs
get_serialized_size(
  const tuw_multi_robot_msgs::msg::RouterStatus & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: id
  {
    size_t item_size = sizeof(ros_message.id);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: success
  {
    size_t item_size = sizeof(ros_message.success);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: missing_robots
  {
    size_t array_size = ros_message.missing_robots.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        (ros_message.missing_robots[index].size() + 1);
    }
  }
  // Member: duration
  {
    size_t item_size = sizeof(ros_message.duration);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: overall_path_length
  {
    size_t item_size = sizeof(ros_message.overall_path_length);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: longest_path_length
  {
    size_t item_size = sizeof(ros_message.longest_path_length);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: priority_scheduling_attemps
  {
    size_t item_size = sizeof(ros_message.priority_scheduling_attemps);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: speed_scheduling_attemps
  {
    size_t item_size = sizeof(ros_message.speed_scheduling_attemps);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_tuw_multi_robot_msgs
max_serialized_size_RouterStatus(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: id
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: success
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint8_t);
    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: missing_robots
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    full_bounded = false;
    is_plain = false;
    for (size_t index = 0; index < array_size; ++index) {
      current_alignment += padding +
        eprosima::fastcdr::Cdr::alignment(current_alignment, padding) +
        1;
    }
  }

  // Member: duration
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: overall_path_length
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: longest_path_length
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: priority_scheduling_attemps
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: speed_scheduling_attemps
  {
    size_t array_size = 1;

    last_member_size = array_size * sizeof(uint32_t);
    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = tuw_multi_robot_msgs::msg::RouterStatus;
    is_plain =
      (
      offsetof(DataType, speed_scheduling_attemps) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static bool _RouterStatus__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const tuw_multi_robot_msgs::msg::RouterStatus *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _RouterStatus__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<tuw_multi_robot_msgs::msg::RouterStatus *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _RouterStatus__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const tuw_multi_robot_msgs::msg::RouterStatus *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _RouterStatus__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_RouterStatus(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _RouterStatus__callbacks = {
  "tuw_multi_robot_msgs::msg",
  "RouterStatus",
  _RouterStatus__cdr_serialize,
  _RouterStatus__cdr_deserialize,
  _RouterStatus__get_serialized_size,
  _RouterStatus__max_serialized_size
};

static rosidl_message_type_support_t _RouterStatus__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_RouterStatus__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_tuw_multi_robot_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<tuw_multi_robot_msgs::msg::RouterStatus>()
{
  return &tuw_multi_robot_msgs::msg::typesupport_fastrtps_cpp::_RouterStatus__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, tuw_multi_robot_msgs, msg, RouterStatus)() {
  return &tuw_multi_robot_msgs::msg::typesupport_fastrtps_cpp::_RouterStatus__handle;
}

#ifdef __cplusplus
}
#endif
